unit f_GIs_Note_Dialog;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, f_OrbisDialog, Vcl.StdCtrls,
  e_GeometryEx,
  Vcl.Buttons, Vcl.ExtCtrls, Vcl.ImgList, Vcl.ComCtrls, Vcl.MPlayer,
  System.ImageList;

type
  TGis_NoteDialog_Form = class(TOrbisDialog_Form)
    Memo1: TMemo;
    ScrollBox: TScrollBox;
    Label1: TLabel;
    Shape1: TShape;
    Image: TImage;
    Label2: TLabel;
    Label3: TLabel;
    ListView: TListView;
    ImageList: TImageList;
    panel_Media: TPanel;
    MediaPlayer: TMediaPlayer;
    BitBtn1: TBitBtn;
    l_Media: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    b_DeleteAudio: TBitBtn;
    b_DeleteFoto: TBitBtn;
    b_DeleteNote: TBitBtn;
    procedure ScrollBoxClick(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ListboxClick(Sender: TObject);
    procedure ListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure MediaPlayerNotify(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure Memo1Change(Sender: TObject);
  private
    FNote: TGis_Note;
    FNewObject: boolean;
    procedure SetNote(const Value: TGis_Note);
    procedure SetNewObject(const Value: boolean);
    { Private declarations }
  public
     Ram: TShape;
     property Note: TGis_Note read FNote write SetNote;
     property NewObject: boolean read FNewObject write SetNewObject;
     procedure AddImages;
     procedure AddAudios;
     procedure SelectImage(aIndex: integer);
  end;


implementation
uses
   e_Type,
   t_Main,
   Elements,
   Worlds;

{$R *.dfm}

procedure TGis_NoteDialog_Form.AddAudios;
var
   i: integer;
   img: TImage;
   FileName: string;
   L: TListItem;
begin
   ListView.Visible := not Note.NoAudios;
   ListView.Items.BeginUpdate;
   ListView.Items.Clear;
   if not Note.NoAudios then
   for i := 0 to Note.Audios.LastIndex do
   begin
      L := ListView.Items.Add;
      L.Data := Note.Audios.StringElements[i];
      L.Caption := Note.Audios.Strings[i];
      L.ImageIndex := 0;
//      L.StateIndex := 0;
   end;
   ListView.Items.EndUpdate;

end;

procedure TGis_NoteDialog_Form.AddImages;
var
   i: integer;
   img: TImage;
   FileName: string;
   Shp: TShape;
begin
   ScrollBox.DestroyComponents;
   Ram := nil;
   Image.Picture.Bitmap := nil;
   if Note = nil then exit;
   if Note.NoImages then exit;
   for I := 0 to Note.Images.LastIndex do
   begin
       Img := TImage.Create(ScrollBox);
       Img.Parent := ScrollBox;
       Img.Width  := 140;
       Img.Height := 140;
       Img.Left := 0;
       Img.Top := 145 * i;
       Img.Proportional := true;
       Img.Center := true;
       FileName := IncludeTrailingPathDelimiter(TMainTool(World.MainTool).GetProjectDataDirectoryEx) + 'img' + PathDelim + Note.Images.Names[i];
       Img.Picture.LoadFromFile(FileName);
       Img.OnClick := ScrollBoxClick;
   end;
   Shp := TShape.Create(ScrollBox);
   Shp.Parent := ScrollBox;
   Shp.Shape := stRoundRect;
   Shp.Left := 0;
   Shp.Top := 0;
   Shp.Width := 140;
   Shp.Height := 140;
   Shp.Brush.Style := bsClear;
   Shp.Pen.Color := clLime;
   Shp.Pen.Width := 4;
   Shp.Visible := true;
   Ram := Shp;
   SelectImage(0);

end;

procedure TGis_NoteDialog_Form.BitBtn1Click(Sender: TObject);
begin
   MediaPlayer.Stop;
   panel_Media.Visible := false;
end;

procedure TGis_NoteDialog_Form.FormKeyPress(Sender: TObject; var Key: Char);
begin
    if Key = #27 then b_Storno.Click;
end;

procedure TGis_NoteDialog_Form.FormMouseWheel(Sender: TObject; Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin

   if ScreenToClient(MousePos).X < ScrollBox.Left then exit;

   if ScrollBox.VertScrollBar.IsScrollBarVisible then
   if WheelDelta > 0 then
      ScrollBox.VertScrollBar.Position := ScrollBox.VertScrollBar.Position - 10
   else
      ScrollBox.VertScrollBar.Position := ScrollBox.VertScrollBar.Position + 10;
end;

procedure TGis_NoteDialog_Form.FormShow(Sender: TObject);
begin
   MediaPlayer.Close;
   panel_Media.Visible := false;
   if (Note = nil) or Note.NoImages then
      b_DeleteFoto.Visible := false;
   inherited;
   Memo1.SetFocus;
end;

procedure TGis_NoteDialog_Form.ListboxClick(Sender: TObject);
var
   i: integer;
   FileName: string;
begin
//   i := ListBox.ItemIndex;
//   FileName := IncludeTrailingPathDelimiter(TMainTool(World.MainTool).GetProjectDataDirectoryEx) + 'audio' + PathDelim + Note.Audios.Names[i];
//   MediaPlayer.Visible := true;
//   MediaPlayer.Close;
//   MediaPlayer.FileName := FileName;
//   MediaPlayer.Open;
//   MediaPlayer.Play;
//   MediaPlayer.Visible := false;
end;

procedure TGis_NoteDialog_Form.ListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
var
   SLE: TStringElement;
   FileName: string;
   l: longint;
   S: string;
begin
   if (Item.Data = nil) or (not (TElement(Item.Data) is TStringElement)) then exit;
   SLE := TStringElement(Item.Data);
   FileName := IncludeTrailingPathDelimiter(TMainTool(World.MainTool).GetProjectDataDirectoryEx) + 'audio' + PathDelim + SLE.Name;
   panel_Media.Visible := true;
   l_Media.Caption := Item.Caption;
   MediaPlayer.Notify := false;
   MediaPlayer.Close;
   MediaPlayer.FileName := FileName;
   MediaPlayer.Open;
   S := '';
   if MediaPlayer.TimeFormat = tfMilliseconds then
   begin
      l := MediaPlayer.Length div 1000;
      S := ' s';
   end
   else
      l := MediaPlayer.Length;

   l_Media.Caption := Item.Caption + #13 + l.ToString + S;
   MediaPlayer.Notify := true;
//   MediaPlayer.Play;
//   MediaPlayer.Visible := true;
//   MediaPlayer.Visible := false;
end;

procedure TGis_NoteDialog_Form.MediaPlayerClick(Sender: TObject;  Button: TMPBtnType; var DoDefault: Boolean);
var
   i: integer;
begin
   inherited;
   DoDefault := true;
   i := ListView.ItemIndex;
   if Button in [btNext,btPrev]  then
   case Button of
      btNext: i := i +1;
      btPrev: i := i -1;
   end;
   if i < 0 then i := ListView.Items.Count - 1;
   if i > ListView.Items.Count - 1 then i := 0;
   ListView.ItemIndex := i;
end;

procedure TGis_NoteDialog_Form.MediaPlayerNotify(Sender: TObject);
begin
//   if not(MediaPlayer.Mode in [mpOpen,mpPlaying])  then
//   MediaPlayer.Visible := false;
end;

procedure TGis_NoteDialog_Form.Memo1Change(Sender: TObject);
begin
   if Note = nil then exit;
   Note.Text := Memo1.Text;
end;

procedure TGis_NoteDialog_Form.ScrollBoxClick(Sender: TObject);
begin
   if Sender is TImage then
   begin
      SelectImage(TImage(Sender).ComponentIndex);
      MediaPlayer.Close;
      Panel_Media.Visible := false;
   end;
end;

procedure TGis_NoteDialog_Form.SelectImage(aIndex: integer);
var
   FileName: string;
begin
   FileName := IncludeTrailingPathDelimiter(TMainTool(World.MainTool).GetProjectDataDirectoryEx) + 'img' + PathDelim + Note.Images.Names[aIndex];
   Image.Picture.LoadFromFile(FileName);
//   Ram.Left := 0;
   Ram.Top := (145 * aIndex) - ScrollBox.VertScrollBar.Position;
   b_DeleteFoto.Visible := true;
end;

procedure TGis_NoteDialog_Form.SetNewObject(const Value: boolean);
begin
  FNewObject := Value;
  b_DeleteNote.Enabled := not Value;
end;

procedure TGis_NoteDialog_Form.SetNote(const Value: TGis_Note);
begin
   FNote := Value;
   if NewObject then
      Caption := 'Nov Poznmka: ' + Value.Name
   else
      Caption := 'Star Poznmka: ' + Value.Name;
   Memo1.Clear;
   Memo1.Lines.Add(Value.Text);
   AddImages;
   AddAudios;
end;

end.
